/******************************************************************************************************************************************************
 * Name         :   TestSalesIQPositionManagementCtlr.cls
 * Description  :   Controller for SalesIQPositionManagement lightning component to handle Create, Edit, delete position and change base overlay association
 * Author       :   Lagnika Sharma
 * Created On   :   14/09/2017
******************************************************************************************************************************************************/
@isTest
public class TestSalesIQPositionManagementCtlr{

    static Position__c districtPos, terrPos, terrPosOverlay, terrPosOverlay1 ;
    static Team_Instance__c baseTeamInstance, overlayTeamInstance;
    static Position_Global_Settings__c posGlobal;
    static Cookie cookieVar;

    static {
        Organization_Master__c org = CallPlanTestDataFactory.createOrganizationMasterRecord();
        insert org;
        Country__c country = CallPlanTestDataFactory.createCountryMasterRecord(org.id);
        insert country;

        cookieVar = new Cookie('CountryID', country.Id,null,-1,false);
        ApexPages.currentPage().setCookies(new Cookie[]{cookieVar});
        
        String ns = SalesIQGlobalConstants.getOrgNameSpace();
        
    	/************** team and team instance update test data  *************/

        TriggerContol__c triggerControlPosition = new TriggerContol__c (IsStopTrigger__c = true , Name='PositionTrigger');
        TriggerContol__c triggerControlCRtrigger = new TriggerContol__c (IsStopTrigger__c = true , Name='ChangeRequestTrigger ');
        insert new TriggerContol__c[] {triggerControlPosition, triggerControlCRtrigger};

    	Alignment_Global_Settings__c alignmentSetting  = new Alignment_Global_Settings__c();
        alignmentSetting.Name = 'TeamCodeMax';
        alignmentSetting.Tree_Hierarchy_Sort_Field__c = '1';

        Alignment_Global_Settings__c alignmentSetting1  = new Alignment_Global_Settings__c();
        alignmentSetting1.Name = 'TeamInstanceCodeMax';
        alignmentSetting1.Tree_Hierarchy_Sort_Field__c = '1';

        insert new Alignment_Global_Settings__c[] {alignmentSetting, alignmentSetting1};

        posGlobal = new Position_Global_Settings__c();
        posGlobal.Name = 'default';
        posGlobal.Child_Effective_Dates_within_Parent__c = true;
        insert posGlobal;

        TotalApproval__c totalApp = new TotalApproval__c(Name='Approvals',No_Of_Approval__c=3);
        insert totalApp;
    	
    	/********* base Team Data *********/
    	Team__c baseTeam = new Team__c(Name='HTN',Type__c='Base',Effective_start_Date__c = Date.newInstance(2015, 1, 1), Effective_End_Date__c = Date.newInstance(2018, 12, 31));
        insert baseTeam;

    	baseTeamInstance =  new Team_Instance__c();
        BaseTeamInstance.Name = 'HTN_Q1_2016';
        BaseTeamInstance.Alignment_Period__c = 'Current';
        BaseTeamInstance.Team__c = baseTeam.id;
        BaseTeamInstance.IC_EffstartDate__c = Date.newInstance(2015, 1, 1);
        BaseTeamInstance.IC_EffendDate__c = Date.newInstance(2022, 12, 31);
        BaseTeamInstance.Alignment_Type__c = 'ZIP';
        BaseTeamInstance.isActiveCycle__c = 'Y'; 
        BaseTeamInstance.IsCascadeDeleteAssignments__c = false;
        insert baseTeamInstance;

        Position__c nation = new Position__c();
        nation.name = 'USA';
        nation.Client_Territory_Name__c = 'North east';
        nation.Client_Position_Code__c = 'Dist0001';
        nation.Client_Territory_Code__c='1NE30000';
        nation.Position_Type__c='Nation';
        nation.inactive__c = false;
        nation.RGB__c = '41,210,117';
        nation.Team_Instance__c = baseTeamInstance.Id;
        nation.Team_iD__c = baseTeam.id;
        nation.Effective_Start_Date__c = Date.newInstance(2015, 1, 1);
        nation.Effective_End_Date__c = Date.newInstance(2018, 12, 31);
        nation.Hierarchy_Level__c = '4';
        insert nation;
        

    	Position__c regionPos =  new Position__c();
        regionPos.Name = 'region';
         regionPos.Client_Territory_Name__c = 'North east';
        regionPos.Client_Position_Code__c = 'Terr0001';
        regionPos.Client_Territory_Code__c='1NE30000';
        regionPos.Position_Type__c='Region';
    	regionPos.inactive__c = false;
        regionPos.RGB__c = '41,210,117';
        regionPos.Team_Instance__c = baseTeamInstance.id;
        regionPos.Team_iD__c = baseTeam.id;
        regionPos.Effective_Start_Date__c = Date.newInstance(2015, 1, 1);
        regionPos.Effective_End_Date__c = Date.newInstance(2018, 12, 31);
        regionPos.Hierarchy_Level__c = '3';
        regionPos.Parent_Position__c = nation.Id;
    	insert regionPos;

        Position_Team_Instance__c regionTeamInstance = CallPlanTestDataFactory.CreatePosTeamInstance(regionPos, null, BaseTeamInstance);
        regionTeamInstance.X_Max__c=-72.6966429900;
        regionTeamInstance.X_Min__c=-73.9625820000;
        regionTeamInstance.Y_Max__c=40.9666490000;
        regionTeamInstance.Y_Min__c=40.5821279800;
        insert regionTeamInstance;

    	districtPos = new Position__c();
        districtPos.name = 'Newyork';
        districtPos.Client_Territory_Name__c = 'Newyork';
        districtPos.Client_Position_Code__c = 'Dist0002';
        districtPos.Client_Territory_Code__c='1NE30001';
        districtPos.Position_Type__c='District';
        districtPos.inactive__c = false;
        districtPos.RGB__c = '41,210,117';
        districtPos.Team_iD__c = baseTeam.id;
        districtPos.Team_Instance__c = baseTeamInstance.id;
        districtPos.Parent_Position__c = regionPos.Id;
        districtPos.Effective_Start_Date__c = Date.newInstance(2015, 1, 1);
        districtPos.Effective_End_Date__c = Date.newInstance(2018, 12, 31);
        districtPos.Hierarchy_Level__c = '2';
        districtPos.Related_Position_Type__c = 'Base';
    	insert districtPos;

        Position_Team_Instance__c districtTeamInstance = CallPlanTestDataFactory.CreatePosTeamInstance(districtPos, regionPos, BaseTeamInstance);
        districtTeamInstance.X_Max__c=-72.6966429900;
        districtTeamInstance.X_Min__c=-73.9625820000;
        districtTeamInstance.Y_Max__c=40.9666490000;
        districtTeamInstance.Y_Min__c=40.5821279800;
        districtTeamInstance.Parent_Position_ID__c = regionPos.id;
        insert districtTeamInstance;

        Position__c district1 = new Position__c();
        district1.name = 'Newyork';
        district1.Client_Territory_Name__c = 'Newyork';
        district1.Client_Position_Code__c = 'Dist0003';
        district1.Client_Territory_Code__c='1NE30001';
        district1.Position_Type__c='District';
        district1.inactive__c = false;
        district1.RGB__c = '41,210,117';
        district1.Team_iD__c = baseTeam.id;
        district1.Team_Instance__c = baseTeamInstance.id;
        district1.Parent_Position__c = regionPos.Id;
        district1.Effective_Start_Date__c = Date.newInstance(2015, 1, 1);
        district1.Effective_End_Date__c = Date.newInstance(2018, 12, 31);
        district1.Hierarchy_Level__c = '2';
        district1.Related_Position_Type__c = 'Base';
        insert district1;

        Position_Team_Instance__c district1TeamInstance = CallPlanTestDataFactory.CreatePosTeamInstance(district1, nation, BaseTeamInstance);
        district1TeamInstance.X_Max__c=-72.6966429900;
        district1TeamInstance.X_Min__c=-73.9625820000;
        district1TeamInstance.Y_Max__c=40.9666490000;
        district1TeamInstance.Y_Min__c=40.5821279800;
        insert district1TeamInstance;

    	terrPos = CallPlanTestDataFactory.createPosition(districtPos, baseTeam);
        terrPos.Name = 'abc';
    	terrPos.Hierarchy_Level__c = '1';
        terrPos.Client_Position_Code__c = 'POS-0009';
        terrPos.inactive__c = false;
        terrPos.Effective_Start_Date__c = System.today();
        terrPos.Effective_End_Date__c = Date.newInstance(2018, 01, 01);
        terrPos.Related_Position_Type__c = 'Base';
        terrPos.Team_Instance__c = baseTeamInstance.Id;
        insert terrPos;

        Position__c territory1 = new Position__c();
        territory1.name = 'Long Island East';
        territory1.Client_Territory_Name__c = 'Long Island East';
        territory1.Client_Position_Code__c = 'Terr0002';
        territory1.Client_Territory_Code__c='1NE30011';
        territory1.Position_Type__c='Territory';
        territory1.inactive__c = false;
        territory1.RGB__c = '41,210,117';
        territory1.Team_Instance__c = baseTeamInstance.id;
        territory1.Team_iD__c = baseTeam.id;
        territory1.Parent_Position__c = districtPos.Id;
        territory1.Effective_End_Date__c = Date.newInstance(2018, 12, 31);
        territory1.Effective_Start_Date__c = Date.newInstance(2015, 1, 1);
        territory1.Related_Position_Type__c = 'Base';
        territory1.Hierarchy_Level__c = '1';
        insert territory1;

    	Position_Team_Instance__c territoryTeamInstance = CallPlanTestDataFactory.CreatePosTeamInstance(terrPos, districtPos, BaseTeamInstance);
        territoryTeamInstance.X_Max__c=-72.6966429900;
        territoryTeamInstance.X_Min__c=-73.9625820000;
        territoryTeamInstance.Y_Max__c=40.9666490000;
        territoryTeamInstance.Y_Min__c=40.5821279800;
        territoryTeamInstance.Parent_Position_ID__c = districtPos.id;
        insert territoryTeamInstance;

    	/******* overlay Team Data ************/

    	Team__c overlayTeam = new Team__c(Name='HTN Overlay',Type__c='Overlay',Effective_start_Date__c = Date.newInstance(2015, 1, 1), Effective_End_Date__c = Date.newInstance(2018, 12, 31), Controlling_Team__c= baseTeam.id);
        overlayTeam.Is_Enforced__c = true;
        insert overlayTeam;

    	overlayTeamInstance = CallPlanTestDataFactory.CreateTeamInstance(overlayTeam, 'Zip');
        overlayTeamInstance.Name = 'HTN_Overlay_2016';
        overlayTeamInstance.Alignment_Period__c= 'Current';
    	overlayTeamInstance.Base_Team_Instance__c = baseTeamInstance.Id;
        overlayTeamInstance.IC_EffstartDate__c = Date.newInstance(2015, 01, 01);
        overlayTeamInstance.IC_EffEndDate__c = Date.newInstance(2025, 01, 01);
        overlayTeamInstance.isActiveCycle__c = 'Y'; 
        overlayTeamInstance.IsCascadeDeleteAssignments__c = true;
        overlayTeamInstance.Converging_Level__c = 2;
    	insert overlayTeamInstance;
 
    	terrPosOverlay = CallPlanTestDataFactory.createPosition(districtPos, overlayTeam);
        terrPosOverlay.Name = 'overlayterritory';
    	terrPosOverlay.Hierarchy_Level__c = '1';
    	terrPosOverlay.Team_Instance__c = overlayTeamInstance.Id;
        terrPosOverlay.Effective_Start_Date__c = Date.newInstance(2014, 01, 01);
        terrPosOverlay.Effective_End_Date__c = Date.newInstance(2019, 01, 01);
        terrPosOverlay.inactive__c = false;
        terrPosOverlay.Related_Position_Type__c = 'Overlay';
    	insert terrPosOverlay;

    	Position_Team_Instance__c territoryTeamInstanceOverlay = CallPlanTestDataFactory.CreatePosTeamInstance(terrPosOverlay, districtPos, overlayTeamInstance);
        territoryTeamInstanceOverlay.X_Max__c=-72.6966429900;
        territoryTeamInstanceOverlay.X_Min__c=-73.9625820000;
        territoryTeamInstanceOverlay.Y_Max__c=40.9666490000;
        territoryTeamInstanceOverlay.Y_Min__c=40.5821279800;
        territoryTeamInstanceOverlay.Parent_Position_ID__c = districtPos.id;
        insert territoryTeamInstanceOverlay;

        Related_Position__c relatedPos = new Related_Position__c();
        relatedPos.Related_Position_Team_Instance__c = territoryTeamInstanceOverlay.id;
        relatedPos.Base_Position_Team_Instance__c = territoryTeamInstance.id;
        relatedPos.Related_Position__c = terrPosOverlay.id;
        relatedPos.Base_Position__C = terrPos.id;
        relatedPos.Effective_Start_Date__c = System.today().addMonths(-1);
        relatedPos.Effective_End_Date__c = System.today().addMonths(1);
        relatedPos.Related_Position_Type__c = SalesIQGlobalConstants.TEAM_TYPE_MIRROR;
        relatedPos.isActive__c = true;

        insert relatedPos;

        terrPosOverlay1 = CallPlanTestDataFactory.createPosition(districtPos, overlayTeam);
        terrPosOverlay1.Name = 'terrPosOverlay';
        terrPosOverlay1.Hierarchy_Level__c = '1';
        terrPosOverlay1.Team_Instance__c = overlayTeamInstance.Id;
        terrPosOverlay1.Effective_Start_Date__c = System.today();
        terrPosOverlay1.Effective_End_Date__c = Date.newInstance(2019, 01, 01);
        terrPosOverlay1.inactive__c = false;
        terrPosOverlay1.Related_Position_Type__c = 'Overlay';
        insert terrPosOverlay1;

        Position_Team_Instance__c territoryTeamInstanceOverlay1 = CallPlanTestDataFactory.CreatePosTeamInstance(terrPosOverlay1, districtPos, overlayTeamInstance);
        territoryTeamInstanceOverlay1.X_Max__c=-72.6966429900;
        territoryTeamInstanceOverlay1.X_Min__c=-73.9625820000;
        territoryTeamInstanceOverlay1.Y_Max__c=40.9666490000;
        territoryTeamInstanceOverlay1.Y_Min__c=40.5821279800;
        territoryTeamInstanceOverlay1.Parent_Position_ID__c = districtPos.id;
        insert territoryTeamInstanceOverlay1;

        /*
        Related_Position__c relatedPos1 = new Related_Position__c();
        relatedPos1.Related_Position_Team_Instance__c = territoryTeamInstanceOverlay1.id;
        relatedPos1.Base_Position_Team_Instance__c = territoryTeamInstance.id;
        relatedPos1.Related_Position__c = terrPosOverlay1.id;
        relatedPos1.Base_Position__C = terrPos.id;
        relatedPos1.isActive__c = true;
        relatedPos1.Effective_Start_Date__c = System.today().addMonths(-1);
        relatedPos1.Effective_End_Date__c = System.today().addMonths(1);
        insert relatedPos1; */

        Position__c districtOverlay = new Position__c();
        districtOverlay.name = 'Newyork Overlay';
        districtOverlay.Client_Territory_Name__c = 'Newyork overlay';
        districtOverlay.Client_Position_Code__c = 'Dist0004';
        districtOverlay.Client_Territory_Code__c='1NE30001overlay';
        districtOverlay.Position_Type__c='District';
        districtOverlay.inactive__c = false;
        districtOverlay.RGB__c = '41,210,117';
        districtOverlay.Team_Instance__c = OverlayTeamInstance.id;
        districtOverlay.Team_iD__c = overlayTeam.id;
        districtOverlay.Parent_Position__c = regionPos.Id;
        districtOverlay.parent_position_code__c = regionPos.Client_Position_Code__c;
        districtOverlay.Effective_End_Date__c = Date.newInstance(2018, 12, 31);
        districtOverlay.Effective_Start_Date__c = Date.newInstance(2015, 1, 1);
        districtOverlay.Hierarchy_Level__c = '2';
        districtOverlay.Related_Position_Type__c = 'Overlay';

        insert districtOverlay;

        

        /******** Unassigned Terr Data ***************/ 

        Position__c unassterrPos = new Position__c();
        unassterrPos.name = 'Long Island East';
        unassterrPos.Team_Instance__c = baseTeamInstance.id;
        unassterrPos.Client_Territory_Name__c = 'Long Island East';
        unassterrPos.Client_Position_Code__c = SalesIQGlobalConstants.UNASSIGNED_TERRITORY_CODE;
        unassterrPos.Client_Territory_Code__c='1NE30011';
        unassterrPos.Position_Type__c='Territory';
        unassterrPos.inactive__c = false;
        unassterrPos.RGB__c = '41,210,117';
        unassterrPos.Team_iD__c = baseTeam.id;
        unassterrPos.Parent_Position__c = districtPos.Id;
        unassterrPos.Effective_End_Date__c = Date.newInstance(2018, 12, 31);
        unassterrPos.Effective_Start_Date__c = Date.newInstance(2015, 1, 1);
        unassterrPos.Related_Position_Type__c = 'Base';
        unassterrPos.Hierarchy_Level__c = '1';
        insert unassterrPos;

    	Position_Team_Instance__c unassterritoryTeamInstance = CallPlanTestDataFactory.CreatePosTeamInstance(unassterrPos, districtPos, BaseTeamInstance);
        unassterritoryTeamInstance.X_Max__c=-72.6966429900;
        unassterritoryTeamInstance.X_Min__c=-73.9625820000;
        unassterritoryTeamInstance.Y_Max__c=40.9666490000;
        unassterritoryTeamInstance.Y_Min__c=40.5821279800;
        
        insert unassterritoryTeamInstance;

        Position__c unassterrPosOverlay = new Position__c();
        unassterrPosOverlay.name = 'Long Island East';
        unassterrPosOverlay.Team_Instance__c = OverlayTeamInstance.id;
        unassterrPosOverlay.Client_Territory_Name__c = 'Long Island East';
        unassterrPosOverlay.Client_Position_Code__c = SalesIQGlobalConstants.UNASSIGNED_TERRITORY_CODE;
        unassterrPosOverlay.Client_Territory_Code__c='1NE30011';
        unassterrPosOverlay.Position_Type__c='Territory';
        unassterrPosOverlay.inactive__c = false;
        unassterrPosOverlay.RGB__c = '41,210,117';
        unassterrPosOverlay.Team_iD__c = overlayTeam.id;
        unassterrPosOverlay.Parent_Position__c = districtPos.Id;
        unassterrPosOverlay.Effective_start_Date__c = Date.newInstance(2015, 1, 1);
        unassterrPosOverlay.Effective_End_Date__c = Date.newInstance(2018, 12, 31);
        //unassterrPosOverlay.Related_Position_Type__c = 'Base';
        unassterrPosOverlay.Hierarchy_Level__c = '1';
        unassterrPosOverlay.Related_Position_Type__c = 'Overlay';
        insert unassterrPosOverlay;

    	Position_Team_Instance__c unassterritoryTeamInstanceOverlay = CallPlanTestDataFactory.CreatePosTeamInstance(unassterrPosOverlay, districtPos, overlayTeamInstance);
        unassterritoryTeamInstanceOverlay.X_Max__c=-72.6966429900;
        unassterritoryTeamInstanceOverlay.X_Min__c=-73.9625820000;
        unassterritoryTeamInstanceOverlay.Y_Max__c=40.9666490000;
        unassterritoryTeamInstanceOverlay.Y_Min__c=40.5821279800;
        unassterritoryTeamInstanceOverlay.Parent_Position_ID__c = districtPos.id;
        insert unassterritoryTeamInstanceOverlay;


        Related_Position__c unassrelatedPos = new Related_Position__c();
        unassrelatedPos.Related_Position_Team_Instance__c = unassterritoryTeamInstanceOverlay.id;
        unassrelatedPos.Base_Position_Team_Instance__c = unassterritoryTeamInstance.id;
        unassrelatedPos.Related_Position__c = unassterrPosOverlay.id;
        unassrelatedPos.Base_Position__C = unassterrPos.id;
        unassrelatedPos.isActive__c = true;
        unassrelatedPos.Effective_Start_Date__c = System.today().addMonths(-1);
        unassrelatedPos.Effective_End_Date__c = System.today().addMonths(1);
        insert unassrelatedPos;

    	/************* configuration data *************/
    	
    	Team_Instance_Object_Attribute__c teamInstAttr =  new Team_Instance_Object_Attribute__c();
        teamInstAttr.Interface_Name__c = SalesIQGlobalConstants.ROSTER_CREATE_POSITION_POPUP;
        teamInstAttr.Attribute_API_Name__c = 'Name';
        teamInstAttr.Object_Name__c = 'Position__c';
        teamInstAttr.Data_Type__c = 'Text';
        teamInstAttr.Attribute_Display_Name__c = 'Position Name';
        teamInstAttr.isEnabled__c = true;
        teamInstAttr.isEditable__c = true;
        teamInstAttr.IsAutoSuggested__c  = false;
        teamInstAttr.isRequired__c   = true;
        teamInstAttr.Team_Instance__c = baseTeamInstance.Id;
        teamInstAttr.Display_Column_Order__c = 1;

        Team_Instance_Object_Attribute__c teamInstAttr2 =  new Team_Instance_Object_Attribute__c();
        teamInstAttr2.Interface_Name__c = SalesIQGlobalConstants.ROSTER_CREATE_POSITION_POPUP;
        teamInstAttr2.Attribute_API_Name__c = SalesIQGlobalConstants.NAME_SPACE  + 'Team_Id__c';
        teamInstAttr2.Object_Name__c = 'Position__c';
        teamInstAttr2.Data_Type__c = 'Lookup';
        teamInstAttr2.Attribute_Display_Name__c = 'Team_Id__c';
        teamInstAttr2.isEnabled__c = true;
        teamInstAttr2.isEditable__c = true;
        teamInstAttr2.IsAutoSuggested__c     = true;
        teamInstAttr2.isRequired__c  = true;
        teamInstAttr2.Team_Instance__c = BaseTeamInstance.Id;
        teamInstAttr2.Display_Column_Order__c = 1;

        Team_Instance_Object_Attribute__c teamInstAttr8 =  new Team_Instance_Object_Attribute__c();
        teamInstAttr8.Interface_Name__c = SalesIQGlobalConstants.ROSTER_CREATE_POSITION_POPUP;
        teamInstAttr8.Attribute_API_Name__c = SalesIQGlobalConstants.NAME_SPACE  + 'Effective_start_Date__c';
        teamInstAttr8.Object_Name__c = 'Position__c';
        teamInstAttr8.Data_Type__c = 'Date';
        teamInstAttr8.Attribute_Display_Name__c = 'Effective Start Date';
        teamInstAttr8.isEnabled__c = true;
        teamInstAttr8.isEditable__c = true;
        teamInstAttr8.IsAutoSuggested__c     = true;
        teamInstAttr8.isRequired__c  = true;
        teamInstAttr8.Team_Instance__c = BaseTeamInstance.Id;
        teamInstAttr8.Display_Column_Order__c = 1;

        Team_Instance_Object_Attribute__c teamInstAttr9 =  new Team_Instance_Object_Attribute__c();
        teamInstAttr9.Interface_Name__c = SalesIQGlobalConstants.ROSTER_CREATE_POSITION_POPUP;
        teamInstAttr9.Attribute_API_Name__c = SalesIQGlobalConstants.NAME_SPACE  + 'Parent_Position__c';
        teamInstAttr9.Object_Name__c = 'Position__c';
        teamInstAttr9.Data_Type__c = 'Lookup';
        teamInstAttr9.Attribute_Display_Name__c = 'Parent_Position__c';
        teamInstAttr9.isEnabled__c = true;
        teamInstAttr9.isEditable__c = true;
        teamInstAttr9.IsAutoSuggested__c     = true;
        teamInstAttr9.isRequired__c  = true;
        teamInstAttr9.Team_Instance__c = BaseTeamInstance.Id;
        teamInstAttr9.Display_Column_Order__c = 1;

        Team_Instance_Object_Attribute__c teamInst9 =  new Team_Instance_Object_Attribute__c();
        teamInst9.Interface_Name__c = SalesIQGlobalConstants.ROSTER_CREATE_POSITION_POPUP;
        teamInst9.Attribute_API_Name__c = SalesIQGlobalConstants.NAME_SPACE  + 'Position_Type__c';
        teamInst9.Object_Name__c = 'Position__c';
        teamInst9.Data_Type__c = 'Picklist';
        teamInst9.Attribute_Display_Name__c = 'Position_Type__c';
        teamInst9.isEnabled__c = true;
        teamInst9.isEditable__c = true;
        teamInst9.IsAutoSuggested__c = true;
        teamInst9.isRequired__c  = true;
        teamInst9.Team_Instance__c = BaseTeamInstance.Id;
        teamInst9.Display_Column_Order__c = 1;
        insert teamInst9;

        Team_Instance_Object_Attribute__c teamInst10 =  new Team_Instance_Object_Attribute__c();
        teamInst10.Interface_Name__c = SalesIQGlobalConstants.ROSTER_CREATE_POSITION_POPUP;
        teamInst10.Attribute_API_Name__c = SalesIQGlobalConstants.NAME_SPACE  + 'Related_Position_Type__c';
        teamInst10.Object_Name__c = 'Position__c';
        teamInst10.Data_Type__c = 'Picklist';
        teamInst10.Attribute_Display_Name__c = 'Related_Position_Type__c';
        teamInst10.isEnabled__c = true;
        teamInst10.isEditable__c = true;
        teamInst10.IsAutoSuggested__c = true;
        teamInst10.isRequired__c  = true;
        teamInst10.Team_Instance__c = BaseTeamInstance.Id;
        teamInst10.Display_Column_Order__c = 1;
        insert teamInst10;

        Team_Instance_Object_Attribute__c teamInst11 =  new Team_Instance_Object_Attribute__c();
        teamInst11.Interface_Name__c = SalesIQGlobalConstants.ROSTER_CREATE_POSITION_POPUP;
        teamInst11.Attribute_API_Name__c = SalesIQGlobalConstants.NAME_SPACE  + 'Position_Category__c';
        teamInst11.Object_Name__c = 'Position__c';
        teamInst11.Data_Type__c = 'Picklist';
        teamInst11.Attribute_Display_Name__c = 'Position_Category__c';
        teamInst11.isEnabled__c = true;
        teamInst11.isEditable__c = true;
        teamInst11.IsAutoSuggested__c = true;
        teamInst11.isRequired__c  = true;
        teamInst11.Team_Instance__c = BaseTeamInstance.Id;
        teamInst11.Display_Column_Order__c = 1;
        insert teamInst11;

        Team_Instance_Object_Attribute__c teamInst12 =  new Team_Instance_Object_Attribute__c();
        teamInst12.Interface_Name__c = SalesIQGlobalConstants.ROSTER_CREATE_POSITION_POPUP;
        teamInst12.Attribute_API_Name__c = SalesIQGlobalConstants.NAME_SPACE.toLowerCase()  + 'Client_Position_Code__c';
        teamInst12.Object_Name__c = 'Position__c';
        teamInst12.Data_Type__c = 'Picklist';
        teamInst12.Attribute_Display_Name__c = 'Client_Position_Code__c';
        teamInst12.isEnabled__c = true;
        teamInst12.isEditable__c = true;
        teamInst12.IsAutoSuggested__c = true;
        teamInst12.isRequired__c  = true;
        teamInst12.Team_Instance__c = BaseTeamInstance.Id;
        teamInst12.Display_Column_Order__c = 1;
        insert teamInst12;

        Team_Instance_Object_Attribute__c teamInstAttr22 =  new Team_Instance_Object_Attribute__c();
        teamInstAttr22.Interface_Name__c = SalesIQGlobalConstants.ROSTER_CREATE_POSITION_POPUP;
        teamInstAttr22.Attribute_API_Name__c = SalesIQGlobalConstants.NAME_SPACE  + 'inactive__c';
        teamInstAttr22.Object_Name__c = 'Position__c';
        teamInstAttr22.Data_Type__c = 'Boolean';
        teamInstAttr22.Attribute_Display_Name__c = 'Inactive';
        teamInstAttr22.isEnabled__c = true;
        teamInstAttr22.isEditable__c = false;
        teamInstAttr22.IsAutoSuggested__c  = false;
        teamInstAttr22.isRequired__c   = true;
        teamInstAttr22.Team_Instance__c = baseTeamInstance.Id;
        teamInstAttr22.Display_Column_Order__c = 1;

        Team_Instance_Object_Attribute__c teamInstAttrEdit =  new Team_Instance_Object_Attribute__c();
        teamInstAttrEdit.Interface_Name__c = SalesIQGlobalConstants.ROSTER_UPDATE_POSITION_ATTRIBUTES;
        teamInstAttrEdit.Attribute_API_Name__c = 'Name';
        teamInstAttrEdit.Object_Name__c = 'Position__c';
        teamInstAttrEdit.Data_Type__c = 'Text';
        teamInstAttrEdit.Attribute_Display_Name__c = 'Position Name';
        teamInstAttrEdit.isEnabled__c = true;
        teamInstAttrEdit.isEditable__c = true;
        teamInstAttrEdit.IsAutoSuggested__c  = false;
        teamInstAttrEdit.isRequired__c   = true;
        teamInstAttrEdit.Team_Instance__c = baseTeamInstance.Id;

        Team_Instance_Object_Attribute__c teamInstAttr1 =  new Team_Instance_Object_Attribute__c();
        teamInstAttr1.Interface_Name__c = SalesIQGlobalConstants.ROSTER_UPDATE_POSITION_ATTRIBUTES;
        teamInstAttr1.Attribute_API_Name__c = SalesIQGlobalConstants.NAME_SPACE  + 'Effective_start_Date__c';
        teamInstAttr1.Object_Name__c = 'Position__c';
        teamInstAttr1.Data_Type__c = 'Date';
        teamInstAttr1.Attribute_Display_Name__c = 'Effective Start Date';
        teamInstAttr1.isEnabled__c = true;
        teamInstAttr1.isEditable__c = true;
        teamInstAttr1.IsAutoSuggested__c     = true;
        teamInstAttr1.isRequired__c  = true;
        teamInstAttr1.Team_Instance__c = BaseTeamInstance.Id;
        teamInstAttr1.Display_Column_Order__c = 1;

        Team_Instance_Object_Attribute__c teamInstAttr3 =  new Team_Instance_Object_Attribute__c();
        teamInstAttr3.Interface_Name__c = SalesIQGlobalConstants.ROSTER_UPDATE_POSITION_ATTRIBUTES;
        teamInstAttr3.Attribute_API_Name__c = 'Name';
        teamInstAttr3.Object_Name__c = 'Position__c';
        teamInstAttr3.Data_Type__c = 'Text';
        teamInstAttr3.Attribute_Display_Name__c = 'Position Name';
        teamInstAttr3.isEnabled__c = true;
        teamInstAttr3.isEditable__c = true;
        teamInstAttr3.IsAutoSuggested__c     = true;
        teamInstAttr3.isRequired__c  = true;
        teamInstAttr3.Team_Instance__c = BaseTeamInstance.Id;
        
        Team_Instance_Object_Attribute__c teamInstAttr4 =  new Team_Instance_Object_Attribute__c();
        teamInstAttr4.Interface_Name__c = SalesIQGlobalConstants.ROSTER_UPDATE_POSITION_ATTRIBUTES;
        teamInstAttr4.Attribute_API_Name__c = SalesIQGlobalConstants.NAME_SPACE  + 'Team_Id__c';
        teamInstAttr4.Object_Name__c = 'Position__c';
        teamInstAttr4.Data_Type__c = 'Lookup';
        teamInstAttr4.Attribute_Display_Name__c = 'Team_Id__c';
        teamInstAttr4.isEnabled__c = true;
        teamInstAttr4.isEditable__c = true;
        teamInstAttr4.IsAutoSuggested__c     = true;
        teamInstAttr4.isRequired__c  = true;
        teamInstAttr4.Team_Instance__c = BaseTeamInstance.Id;

        Team_Instance_Object_Attribute__c teamInstAttr5 =  new Team_Instance_Object_Attribute__c();
        teamInstAttr5.Interface_Name__c = SalesIQGlobalConstants.ROSTER_HIERARCHY_CHANGE_POPUP;
        teamInstAttr5.Attribute_API_Name__c = SalesIQGlobalConstants.NAME_SPACE  + 'Team_Id__c';
        teamInstAttr5.Object_Name__c = 'Position__c';
        teamInstAttr5.Data_Type__c = 'Lookup';
        teamInstAttr5.Attribute_Display_Name__c = 'Team_Id__c';
        teamInstAttr5.isEnabled__c = true;
        teamInstAttr5.isEditable__c = true;
        teamInstAttr5.IsAutoSuggested__c     = true;
        teamInstAttr5.isRequired__c  = true;
        teamInstAttr5.Team_Instance__c = BaseTeamInstance.Id;
        
        Team_Instance_Object_Attribute__c teamInstAttr6 =  new Team_Instance_Object_Attribute__c();
        teamInstAttr6.Interface_Name__c = SalesIQGlobalConstants.ROSTER_HIERARCHY_CHANGE_POPUP;
        teamInstAttr6.Attribute_API_Name__c = ns+'Client_Position_Code__c';
        teamInstAttr6.Object_Name__c = 'Position__c';
        teamInstAttr6.Data_Type__c = 'Text';
        teamInstAttr6.Attribute_Display_Name__c = 'Position Code';
        teamInstAttr6.isEnabled__c = true;
        teamInstAttr6.isEditable__c = true;
        teamInstAttr6.IsAutoSuggested__c     = true;
        teamInstAttr6.isRequired__c  = true;
        teamInstAttr6.Team_Instance__c = overlayTeamInstance.Id;
        teamInstAttr6.Display_Column_Order__c = 2;
        
        Team_Instance_Object_Attribute__c teamInstAttr7 =  new Team_Instance_Object_Attribute__c();
        teamInstAttr7.Interface_Name__c = SalesIQGlobalConstants.ROSTER_HIERARCHY_CHANGE_POPUP;
        teamInstAttr7.Attribute_API_Name__c = 'Name';
        teamInstAttr7.Object_Name__c = 'Position__c';
        teamInstAttr7.Data_Type__c = 'Text';
        teamInstAttr7.Attribute_Display_Name__c = 'Position Name';
        teamInstAttr7.isEnabled__c = true;
        teamInstAttr7.isEditable__c = true;
        teamInstAttr7.IsAutoSuggested__c     = true;
        teamInstAttr7.isRequired__c  = true;
        teamInstAttr7.Team_Instance__c = overlayTeamInstance.Id;
        teamInstAttr7.Display_Column_Order__c = 1;

        Team_Instance_Object_Attribute__c teamInstAttr10 =  new Team_Instance_Object_Attribute__c();
        teamInstAttr10.Interface_Name__c = SalesIQGlobalConstants.ROSTER_DELETE_POSITION_POPUP; 
        teamInstAttr10.Attribute_API_Name__c = SalesIQGlobalConstants.NAME_SPACE  + 'Team_Id__c';
        teamInstAttr10.Object_Name__c = 'Position__c';
        teamInstAttr10.Data_Type__c = 'Lookup';
        teamInstAttr10.Attribute_Display_Name__c = 'Team_Id__c';
        teamInstAttr10.isEnabled__c = true;
        teamInstAttr10.isEditable__c = true;
        teamInstAttr10.IsAutoSuggested__c     = true;
        teamInstAttr10.isRequired__c  = true;
        teamInstAttr10.Team_Instance__c = BaseTeamInstance.Id;
        
        Team_Instance_Object_Attribute__c teamInstAttr11 =  new Team_Instance_Object_Attribute__c();
        teamInstAttr11.Interface_Name__c = SalesIQGlobalConstants.ROSTER_DELETE_POSITION_POPUP; 
        teamInstAttr11.Attribute_API_Name__c = ns+'Client_Position_Code__c';
        teamInstAttr11.Object_Name__c = 'Position__c';
        teamInstAttr11.Data_Type__c = 'Text';
        teamInstAttr11.Attribute_Display_Name__c = 'Position Code';
        teamInstAttr11.isEnabled__c = true;
        teamInstAttr11.isEditable__c = true;
        teamInstAttr11.IsAutoSuggested__c = true;
        teamInstAttr11.isRequired__c  = true;
        teamInstAttr11.Team_Instance__c = baseTeamInstance.Id;
        teamInstAttr11.Display_Column_Order__c = 2;
        
        Team_Instance_Object_Attribute__c teamInstAttr12 =  new Team_Instance_Object_Attribute__c();
        teamInstAttr12.Interface_Name__c = SalesIQGlobalConstants.ROSTER_DELETE_POSITION_POPUP; 
        teamInstAttr12.Attribute_API_Name__c = SalesIQGlobalConstants.NAME_SPACE  + 'Effective_End_Date__c';
        teamInstAttr12.Object_Name__c = 'Position__c';
        teamInstAttr12.Data_Type__c = 'Date';
        teamInstAttr12.Attribute_Display_Name__c = 'Effective End Date';
        teamInstAttr12.isEnabled__c = true;
        teamInstAttr12.isEditable__c = true;
        teamInstAttr12.IsAutoSuggested__c     = true;
        teamInstAttr12.isRequired__c  = true;
        teamInstAttr12.Team_Instance__c = baseTeamInstance.Id;
        teamInstAttr12.Display_Column_Order__c = 1;

        /*Team_Instance_Object_Attribute__c teamInstAttr13 =  new Team_Instance_Object_Attribute__c();
        teamInstAttr13.Interface_Name__c = SalesIQGlobalConstants.ROSTER_DELETE_POSITION_POPUP; 
        teamInstAttr13.Attribute_API_Name__c = SalesIQGlobalConstants.NAME_SPACE  + 'Team_Id__c';
        teamInstAttr13.Object_Name__c = 'Position__c';
        teamInstAttr13.Data_Type__c = 'Lookup';
        teamInstAttr13.Attribute_Display_Name__c = 'Team_Id__c';
        teamInstAttr13.isEnabled__c = true;
        teamInstAttr13.isEditable__c = false;
        teamInstAttr13.IsAutoSuggested__c     = true;
        teamInstAttr13.isRequired__c  = true;
        teamInstAttr13.Team_Instance__c = overlayTeamInstance.Id;*/

        Team_Instance_Object_Attribute__c teamInstAttr14 =  new Team_Instance_Object_Attribute__c();
        teamInstAttr14.Interface_Name__c = SalesIQGlobalConstants.ROSTER_DELETE_POSITION_POPUP; 
        teamInstAttr14.Attribute_API_Name__c = ns+'Client_Position_Code__c';
        teamInstAttr14.Object_Name__c = 'Position__c';
        teamInstAttr14.Data_Type__c = 'Text';
        teamInstAttr14.Attribute_Display_Name__c = 'Position Code';
        teamInstAttr14.isEnabled__c = true;
        teamInstAttr14.isEditable__c = false;
        teamInstAttr14.IsAutoSuggested__c     = true;
        teamInstAttr14.isRequired__c  = true;
        teamInstAttr14.Team_Instance__c = overlayTeamInstance.Id;
        teamInstAttr14.Display_Column_Order__c = 2;
        
        Team_Instance_Object_Attribute__c teamInstAttr15 =  new Team_Instance_Object_Attribute__c();
        teamInstAttr15.Interface_Name__c = SalesIQGlobalConstants.ROSTER_DELETE_POSITION_POPUP; 
        teamInstAttr15.Attribute_API_Name__c = SalesIQGlobalConstants.NAME_SPACE  + 'Effective_End_Date__c';
        teamInstAttr15.Object_Name__c = 'Position__c';
        teamInstAttr15.Data_Type__c = 'Date';
        teamInstAttr15.Attribute_Display_Name__c = 'Effective End Date';
        teamInstAttr15.isEnabled__c = true;
        teamInstAttr15.isEditable__c = true;
        teamInstAttr15.IsAutoSuggested__c   = false;
        teamInstAttr15.isRequired__c  = true;
        teamInstAttr15.Team_Instance__c = overlayTeamInstance.Id;
        teamInstAttr15.Display_Column_Order__c = 1;

        Team_Instance_Object_Attribute__c teamInstAttr16 =  new Team_Instance_Object_Attribute__c();
        teamInstAttr16.Interface_Name__c = SalesIQGlobalConstants.ROSTER_UPDATE_POSITION_ATTRIBUTES;
        teamInstAttr16.Attribute_API_Name__c = SalesIQGlobalConstants.NAME_SPACE  + 'Effective_start_Date__c';
        teamInstAttr16.Object_Name__c = 'Position__c';
        teamInstAttr16.Data_Type__c = 'Date';
        teamInstAttr16.Attribute_Display_Name__c = 'Effective Start Date';
        teamInstAttr16.isEnabled__c = true;
        teamInstAttr16.isEditable__c = true;
        teamInstAttr16.IsAutoSuggested__c     = true;
        teamInstAttr16.isRequired__c  = true;
        teamInstAttr16.Team_Instance__c = overlayTeamInstance.Id;
        teamInstAttr16.Display_Column_Order__c = 1;

        Team_Instance_Object_Attribute__c teamInstAttr17 =  new Team_Instance_Object_Attribute__c();
        teamInstAttr17.Interface_Name__c = SalesIQGlobalConstants.ROSTER_UPDATE_POSITION_ATTRIBUTES;
        teamInstAttr17.Attribute_API_Name__c = 'Name';
        teamInstAttr17.Object_Name__c = 'Position__c';
        teamInstAttr17.Data_Type__c = 'Text';
        teamInstAttr17.Attribute_Display_Name__c = 'Position Name';
        teamInstAttr17.isEnabled__c = true;
        teamInstAttr17.isEditable__c = true;
        teamInstAttr17.IsAutoSuggested__c     = true;
        teamInstAttr17.isRequired__c  = true;
        teamInstAttr17.Team_Instance__c = overlayTeamInstance.Id;

        /*Team_Instance_Object_Attribute__c teamInstAttr18 =  new Team_Instance_Object_Attribute__c();
        teamInstAttr18.Interface_Name__c = SalesIQGlobalConstants.ROSTER_UPDATE_POSITION_ATTRIBUTES;
        teamInstAttr18.Attribute_API_Name__c = SalesIQGlobalConstants.NAME_SPACE  + 'Team_Id__c';
        teamInstAttr18.Object_Name__c = 'Position__c';
        teamInstAttr18.Data_Type__c = 'Lookup';
        teamInstAttr18.Attribute_Display_Name__c = 'Team_Id__c';
        teamInstAttr18.isEnabled__c = true;
        teamInstAttr18.isEditable__c = true;
        teamInstAttr18.IsAutoSuggested__c     = true;
        teamInstAttr18.isRequired__c  = true;
        teamInstAttr18.Team_Instance__c = overlayTeamInstance.Id;*/
        
        Team_Instance_Object_Attribute__c teamInstAttr19 =  new Team_Instance_Object_Attribute__c();
        teamInstAttr19.Interface_Name__c = SalesIQGlobalConstants.ROSTER_EDIT_POSITION_POPUP;
        teamInstAttr19.Attribute_API_Name__c = SalesIQGlobalConstants.NAME_SPACE  + 'Team_Id__c';
        teamInstAttr19.Object_Name__c = 'Position__c';
        teamInstAttr19.Data_Type__c = 'Lookup';
        teamInstAttr19.Attribute_Display_Name__c = 'Team_Id__c';
        teamInstAttr19.isEnabled__c = true;
        teamInstAttr19.isEditable__c = false;
        teamInstAttr19.IsAutoSuggested__c = true;
        teamInstAttr19.isRequired__c  = true;
        teamInstAttr19.Team_Instance__c = overlayTeamInstance.Id;

        Team_Instance_Object_Attribute__c teamInstAttr23 =  new Team_Instance_Object_Attribute__c();
        teamInstAttr23.Interface_Name__c = SalesIQGlobalConstants.ROSTER_EDIT_POSITION_POPUP;
        teamInstAttr23.Attribute_API_Name__c = 'Name';
        teamInstAttr23.Object_Name__c = 'Position__c';
        teamInstAttr23.Data_Type__c = 'Text';
        teamInstAttr23.Attribute_Display_Name__c = 'Name';
        teamInstAttr23.isEnabled__c = true;
        teamInstAttr23.isEditable__c = true;
        teamInstAttr23.IsAutoSuggested__c = false;
        teamInstAttr23.isRequired__c  = true;
        teamInstAttr23.Team_Instance__c = overlayTeamInstance.Id;

        Team_Instance_Object_Attribute__c teamInstAttrEdit20 =  new Team_Instance_Object_Attribute__c();
        teamInstAttrEdit20.Interface_Name__c = SalesIQGlobalConstants.ROSTER_UPDATE_POSITION_ATTRIBUTES;
        teamInstAttrEdit20.Attribute_API_Name__c = 'Name';
        teamInstAttrEdit20.Object_Name__c = 'Position__c';
        teamInstAttrEdit20.Data_Type__c = 'Text';
        teamInstAttrEdit20.Attribute_Display_Name__c = 'Position Name';
        teamInstAttrEdit20.isEnabled__c = true;
        teamInstAttrEdit20.isEditable__c = true;
        teamInstAttrEdit20.IsAutoSuggested__c  = false;
        teamInstAttrEdit20.isRequired__c   = true;
        teamInstAttrEdit20.Team_Instance__c = baseTeamInstance.Id;

        /*Team_Instance_Object_Attribute__c teamInstAttrEdit21 =  new Team_Instance_Object_Attribute__c();
        teamInstAttrEdit21.Interface_Name__c = SalesIQGlobalConstants.ROSTER_UPDATE_POSITION_ATTRIBUTES;
        teamInstAttrEdit21.Attribute_API_Name__c = 'Parent_Position__c';
        teamInstAttrEdit21.Object_Name__c = 'Position__c';
        teamInstAttrEdit21.Data_Type__c = 'Lookup';
        teamInstAttrEdit21.Attribute_Display_Name__c = 'Parent Position';
        teamInstAttrEdit21.isEnabled__c = true;
        teamInstAttrEdit21.isEditable__c = true;
        teamInstAttrEdit21.IsAutoSuggested__c  = false;
        teamInstAttrEdit21.isRequired__c   = true;
        teamInstAttrEdit21.Team_Instance__c = baseTeamInstance.Id;*/


        

        insert new Team_Instance_Object_Attribute__c[] {teamInstAttr1, teamInstAttr2, teamInstAttr3, teamInstAttr4, teamInstAttr5, 
            teamInstAttr6, teamInstAttr7, teamInstAttr8, teamInstAttr9, teamInstAttr10, teamInstAttr11, teamInstAttr12, 
            teamInstAttr14, teamInstAttr15, teamInstAttr16, teamInstAttr17, teamInstAttr19, 
            teamInstAttr, teamInstAttrEdit, teamInstAttrEdit20, teamInstAttr22, teamInstAttr23};
        //teamInstAttr13, teamInstAttrEdit21, teamInstAttr18

        Team_Instance_Configuration__c teamInsConfTerr = new Team_Instance_Configuration__c();
        teamInsConfTerr.Configuration_Type__c = 'Client Position Code';
        teamInsConfTerr.name = 'TerrConfig';
        teamInsConfTerr.Hierarchy_Level__c = '1';
        teamInsConfTerr.Pattern_Value__c = 'Terr{0000}';
        teamInsConfTerr.Position_Type__c = 'Territory';

        
        string teamID = baseTeam.id;
        if(teamId.length() > 15){
            teamID = teamID.left(15);
        }
        
        teamInsConfTerr.Team__c = teamID;
        teamInsConfTerr.Team_Instance__c = BaseTeamInstance.id;
         
        Team_Instance_Configuration__c teamInsConfDistr = new Team_Instance_Configuration__c();
        teamInsConfDistr.Configuration_Type__c = 'Client Position Code';
        teamInsConfDistr.name = 'DistrictConfig';
        teamInsConfDistr.Hierarchy_Level__c = '2';
        teamInsConfDistr.Pattern_Value__c = 'Dist{0000}';
        teamInsConfDistr.Position_Type__c = 'District';
        teamInsConfDistr.Team__c = teamID;
        teamInsConfDistr.Team_Instance__c = BaseTeamInstance.id;

        insert new Team_Instance_Configuration__c[]{teamInsConfTerr, teamInsConfDistr};
        

        CR_Team_Instance_Config__c crTeamInstConf = new CR_Team_Instance_Config__c();
        crTeamInstConf.Configuration_Value__c = 'Territory';
        crTeamInstConf.Configuration_Type__c = 'Hierarchy Configuration';
        crTeamInstConf.Configuration_Name__c = '1';
        crTeamInstConf.team_instance__c = BaseTeamInstance.id;
        
        CR_Team_Instance_Config__c crTeamInstConfDistrict = new CR_Team_Instance_Config__c();
        crTeamInstConfDistrict.Configuration_Value__c = 'District';
        crTeamInstConfDistrict.Configuration_Type__c = 'Hierarchy Configuration';
        crTeamInstConfDistrict.Configuration_Name__c = '2';
        crTeamInstConfDistrict.team_instance__c = BaseTeamInstance.id;

        CR_Team_Instance_Config__c crTeamInstConfOverlayTerritory = new CR_Team_Instance_Config__c();
        crTeamInstConfOverlayTerritory.Configuration_Value__c = 'Territory';
        crTeamInstConfOverlayTerritory.Configuration_Type__c = 'Hierarchy Configuration';
        crTeamInstConfOverlayTerritory.Configuration_Name__c = '1';
        crTeamInstConfOverlayTerritory.team_instance__c = overlayTeamInstance.id;
        
        CR_Team_Instance_Config__c crTeamInstConfOverlayDistrict = new CR_Team_Instance_Config__c();
        crTeamInstConfOverlayDistrict.Configuration_Value__c = 'District';
        crTeamInstConfOverlayDistrict.Configuration_Type__c = 'Hierarchy Configuration';
        crTeamInstConfOverlayDistrict.Configuration_Name__c = '2';
        crTeamInstConfOverlayDistrict.team_instance__c = overlayTeamInstance.id;

        insert new CR_Team_Instance_Config__c[]{crTeamInstConf, crTeamInstConfDistrict, crTeamInstConfOverlayTerritory, crTeamInstConfOverlayDistrict} ;
        
        Change_Request_Type__c newPositionReqType =  CallPlanTestDataFactory.CreateRequestType(SalesIQGlobalConstants.ROSTER);
        Change_Request_Type__c newPositionReqType1 =  CallPlanTestDataFactory.CreateRequestType(SalesIQGlobalConstants.DELETE_POSITION);
        Change_Request_Type__c newPositionReqType2 =  CallPlanTestDataFactory.CreateRequestType(SalesIQGlobalConstants.Update_POSITION);
        Change_Request_Type__c newPositionReqType3 =  CallPlanTestDataFactory.CreateRequestType(SalesIQGlobalConstants.Create_POSITION);
		Change_Request_Type__c newPositionReqType4 =  CallPlanTestDataFactory.CreateRequestType(SalesIQGlobalConstants.DELETE_Overlay_POSITION);
        Change_Request_Type__c newPositionReqType5 =  CallPlanTestDataFactory.CreateRequestType(SalesIQGlobalConstants.Update_Overlay_POSITION);
        Change_Request_Type__c newPositionReqType6 =  CallPlanTestDataFactory.CreateRequestType(SalesIQGlobalConstants.Create_Overlay_POSITION);
        Change_Request_Type__c newPositionReqType7 =  CallPlanTestDataFactory.CreateRequestType(SalesIQGlobalConstants.HIERARCHY_CHANGE);
        Change_Request_Type__c newPositionReqType8 = CallPlanTestDataFactory.CreateRequestType(SalesIQGlobalConstants.HIERARCHY_CHANGE_OVERLAY);
        Change_Request_Type__c newPositionReqType9 = CallPlanTestDataFactory.CreateRequestType(SalesIQGlobalConstants.UPDATE_POSITION_ATTRIBUTES);

        insert new Change_Request_Type__c[]{newPositionReqType9, newPositionReqType, newPositionReqType1, newPositionReqType2, newPositionReqType3,newPositionReqType4,newPositionReqType5,newPositionReqType6,newPositionReqType7,newPositionReqType8};
        
        CR_Approval_Config__c appConfig = new CR_Approval_Config__c(Team_Instance_ID__c = BaseTeamInstance.Id, Change_Request_Type__c = newPositionReqType.Id, HO_Office_User__c = 'Y', HR_User__c = 'N', IsImpactedPosition__c = false, isHigherLevelManagers__c = false, isImpactedManager__c = false);
        CR_Approval_Config__c appConfig1 = new CR_Approval_Config__c(Team_Instance_ID__c = BaseTeamInstance.Id, Change_Request_Type__c = newPositionReqType1.Id, HO_Office_User__c = 'Y', HR_User__c = 'N', IsImpactedPosition__c = false, isHigherLevelManagers__c = false, isImpactedManager__c = false);
        CR_Approval_Config__c appConfig2 = new CR_Approval_Config__c(Team_Instance_ID__c = BaseTeamInstance.Id, Change_Request_Type__c = newPositionReqType2.Id, HO_Office_User__c = 'Y', HR_User__c = 'N', IsImpactedPosition__c = false, isHigherLevelManagers__c = false, isImpactedManager__c = false);
        CR_Approval_Config__c appConfig3 = new CR_Approval_Config__c(Team_Instance_ID__c = BaseTeamInstance.Id, Change_Request_Type__c = newPositionReqType3.Id, HO_Office_User__c = 'Y', HR_User__c = 'N', IsImpactedPosition__c = false, isHigherLevelManagers__c = false, isImpactedManager__c = false);
        CR_Approval_Config__c appConfig4 = new CR_Approval_Config__c(Team_Instance_ID__c = overlayTeamInstance.Id, Change_Request_Type__c = newPositionReqType.Id, HO_Office_User__c = 'Y', HR_User__c = 'N', IsImpactedPosition__c = false, isHigherLevelManagers__c = false, isImpactedManager__c = false);
        CR_Approval_Config__c appConfig5 = new CR_Approval_Config__c(Team_Instance_ID__c = overlayTeamInstance.Id, Change_Request_Type__c = newPositionReqType1.Id, HO_Office_User__c = 'Y', HR_User__c = 'N', IsImpactedPosition__c = false, isHigherLevelManagers__c = false, isImpactedManager__c = false);
        CR_Approval_Config__c appConfig6 = new CR_Approval_Config__c(Team_Instance_ID__c = overlayTeamInstance.Id, Change_Request_Type__c = newPositionReqType5.Id, HO_Office_User__c = 'Y', HR_User__c = 'N', IsImpactedPosition__c = false, isHigherLevelManagers__c = false, isImpactedManager__c = false);
        CR_Approval_Config__c appConfig7 = new CR_Approval_Config__c(Team_Instance_ID__c = overlayTeamInstance.Id, Change_Request_Type__c = newPositionReqType6.Id, HO_Office_User__c = 'Y', HR_User__c = 'N', IsImpactedPosition__c = false, isHigherLevelManagers__c = false, isImpactedManager__c = false);
        CR_Approval_Config__c appConfig8 = new CR_Approval_Config__c(Team_Instance_ID__c = BaseTeamInstance.Id, Change_Request_Type__c = newPositionReqType7.Id, HO_Office_User__c = 'Y', HR_User__c = 'N', IsImpactedPosition__c = false, isHigherLevelManagers__c = false, isImpactedManager__c = false);
        CR_Approval_Config__c appConfig9 = new CR_Approval_Config__c(Team_Instance_ID__c = overlayTeamInstance.Id, Change_Request_Type__c = newPositionReqType8.Id, HO_Office_User__c = 'Y', HR_User__c = 'N', IsImpactedPosition__c = false, isHigherLevelManagers__c = false, isImpactedManager__c = false);
        CR_Approval_Config__c appConfig10 = new CR_Approval_Config__c(Team_Instance_ID__c = overlayTeamInstance.Id, Change_Request_Type__c = newPositionReqType9.Id, HO_Office_User__c = 'Y', HR_User__c = 'N', IsImpactedPosition__c = false, isHigherLevelManagers__c = false, isImpactedManager__c = false);
        CR_Approval_Config__c appConfig11 = new CR_Approval_Config__c(Team_Instance_ID__c = baseTeamInstance.Id, Change_Request_Type__c = newPositionReqType9.Id, HO_Office_User__c = 'Y', HR_User__c = 'N', IsImpactedPosition__c = false, isHigherLevelManagers__c = false, isImpactedManager__c = false);
        insert new CR_Approval_Config__c[]{appConfig11,appConfig, appConfig1, appConfig2, appConfig3,appConfig4, appConfig5, appConfig6, appConfig7,appConfig8,appConfig9,appConfig10};
        
        list<Profile> hoProfile = [SELECT Id FROM Profile WHERE Name =: SalesIQGlobalConstants.HR_PROFILE limit 1];
        if(hoProfile.size() == 0){
            hoProfile = [SELECT Id FROM Profile WHERE Name = 'System Administrator' limit 1];
        }
        
    }

    static testMethod void createBasePosition(){

        SalesIQPositionManagementCtlr.getLocaleDateFormats();
        SalesIQPositionManagementCtlr.logException('No Error Found', SalesIQGlobalConstants.POSITION_UNIVERSE);
        /***************** create base position *************/
        ObjectDetailWrapper wrapper = SalesIQPositionManagementCtlr.initPositionModal('Create Position', districtPos.Id, baseTeamInstance.Id);
       	SalesIQPositionManagementCtlr.validatePosition('Create Position',baseTeamInstance.Id, JSON.serialize(wrapper),'','d/M/yyyy');
        SalesIQPositionManagementCtlr.confirmSubmitRequest('Create Position', districtPos.Id,baseTeamInstance.Id, JSON.serialize(wrapper),'','[]','d/M/yyyy');
        SalesIQPositionManagementCtlr.generatePositionCode(baseTeamInstance.Id,'Territory','1');
        SalesIQPositionManagementCtlr.isBusinessRuleRunning(baseTeamInstance.Id);

        SalesIQPositionManagementCtlr.getMirrorPositionData(districtPos.Id, baseTeamInstance.Id, 'Create');
    }

    static testMethod void createOverlayPosition(){
        /********** create overlay position ****************/
        ObjectDetailWrapper wrappercr = SalesIQPositionManagementCtlr.initPositionModal('Create Position', districtPos.Id, overlayTeamInstance.Id);
        list<ObjectDetailWrapper.BasePositionsWrapper> basePositionsList1 = SalesIQPositionManagementCtlr.getBasePositionData(districtPos.Id, overlayTeamInstance.Id, 'Create Position');
        SalesIQPositionManagementCtlr.validatePosition('Create Position',overlayTeamInstance.Id, JSON.serialize(wrappercr),JSON.serialize(basePositionsList1),'d/M/yyyy');
        SalesIQPositionManagementCtlr.confirmSubmitRequest('Create Position', districtPos.Id,overlayTeamInstance.Id, JSON.serialize(wrappercr),JSON.serialize(basePositionsList1),'[]','d/M/yyyy');


    }

    static testMethod void updatePositionAttribute(){     
        /*********** Update Position Attributes ***************/
        ObjectDetailWrapper wrapperupdate  = SalesIQPositionManagementCtlr.initPositionModal('Update Position Attributes', districtPos.Id, baseTeamInstance.Id);

         for(ObjectDetailWrapper.PositionAttributeWrapper posWrapper : wrapperupdate.positionAttributes){
            for(ObjectDetailWrapper.FieldDetailWrapper fieldWrapper : posWrapper.rowDataConfig){

                if(fieldWrapper.fieldDataType == 'Text'){
                    if(fieldWrapper.fieldLabel == 'Position Name'){
                        System.debug('fieldWrapper -- '+fieldWrapper);
                       
                        fieldWrapper.fieldValue = 'xyz edit';
                        System.debug('fieldWrapper -- '+fieldWrapper);
                    }
                    
                }
                
            }
        }
        districtPos.Effective_End_Date__c = Date.newInstance(2013, 01, 01);
        districtPos.Effective_Start_Date__c = Date.newInstance(2018, 01, 01);
        districtPos.Client_Territory_Code__c = '1NE30011';
        update districtPos;
        try{
            SalesIQPositionManagementCtlr.validatePosition('Update Position Attributes',baseTeamInstance.Id, JSON.serialize(wrapperupdate),'','d/M/yyyy');
        }
        catch(Exception e){

        }
        try{
            SalesIQPositionManagementCtlr.confirmSubmitRequest(SalesIQGlobalConstants.Update_POSITION, districtPos.Id,baseTeamInstance.Id, JSON.serialize(wrapperupdate),'','[]','d/M/yyyy');
        }catch(Exception e){

        }
        

        ObjectDetailWrapper wrapperupdate1 = SalesIQPositionManagementCtlr.initPositionModal('Update Position Attributes', terrPosOverlay.Id, overlayTeamInstance.Id);
        for(ObjectDetailWrapper.PositionAttributeWrapper posWrapper : wrapperupdate1.positionAttributes){
            for(ObjectDetailWrapper.FieldDetailWrapper fieldWrapper1 : posWrapper.rowDataConfig){

                if(fieldWrapper1.fieldDataType == 'Text'){
                    if(fieldWrapper1.fieldLabel == 'Position Name'){
                        System.debug('fieldWrapper -- '+fieldWrapper1);
                       
                        fieldWrapper1.fieldValue = 'xyz edit';
                        System.debug('fieldWrapper -- '+fieldWrapper1);
                    }
                    
                }
                
            }
        }
        try{
            SalesIQPositionManagementCtlr.validatePosition('Update Position Attributes',overlayTeamInstance.Id, JSON.serialize(wrapperupdate1),'','d/M/yyyy');
        }
        catch(Exception e){
            
        }
        
        try{
            SalesIQPositionManagementCtlr.confirmSubmitRequest('Update Position Attributes', terrPosOverlay.Id,overlayTeamInstance.Id, JSON.serialize(wrapperupdate1),'','[]','d/M/yyyy');
            SalesIQPositionManagementCtlr.confirmSubmitRequest('Update Position Attributes',terrPos.Id,baseTeamInstance.Id, JSON.serialize(wrapperupdate1),'','[]','d/M/yyyy');
        }catch(Exception e){}
    }

    static testMethod void editHierarchy(){
        /********** Edit Hierarchy *****************/

        ObjectDetailWrapper hierarchyWrapper = SalesIQPositionManagementCtlr.initPositionModal('Edit Position Hierarchy', districtPos.Id, baseTeamInstance.Id);
        SalesIQPositionManagementCtlr.validatePosition('Edit Position Hierarchy',baseTeamInstance.Id, JSON.serialize(hierarchyWrapper),'','d/M/yyyy');
        SalesIQPositionManagementCtlr.confirmSubmitRequest('Edit Position Hierarchy', districtPos.Id,baseTeamInstance.Id, JSON.serialize(hierarchyWrapper),'','[]','d/M/yyyy');

        ObjectDetailWrapper hierarchyWrapper1 = SalesIQPositionManagementCtlr.initPositionModal('Edit Position Hierarchy', districtPos.Id, overlayTeamInstance.Id);
        SalesIQPositionManagementCtlr.validatePosition('Edit Position Hierarchy',overlayTeamInstance.Id, JSON.serialize(hierarchyWrapper1),'','d/M/yyyy');
        SalesIQPositionManagementCtlr.confirmSubmitRequest('Edit Position Hierarchy', districtPos.Id,overlayTeamInstance.Id, JSON.serialize(hierarchyWrapper1),'','[]','d/M/yyyy');
    }

    static testMethod void editOverlayAssociation(){
        
        /********* Edit Overlay Association ****************/
        SalesIQPositionManagementCtlr.getBasePositionsFromRelatedPositions(terrPosOverlay.Id, overlayTeamInstance.Id);
       
        ObjectDetailWrapper.FieldDetailWrapper wrapper1 = new ObjectDetailWrapper.FieldDetailWrapper();
        wrapper1.fieldApiName = SalesIQGlobalConstants.CHANGE_EFFECTIVE_DATE_LABEL;
        wrapper1.fieldLabel = SalesIQGlobalConstants.CHANGE_EFFECTIVE_DATE_LABEL;
        wrapper1.isRequired = true;
        wrapper1.fieldDataType = 'Date';
        wrapper1.fieldValue = '01-01-2015';
        wrapper1.isEditable = false;
        
        test.startTest();
        ObjectDetailWrapper editWrapper = SalesIQPositionManagementCtlr.initPositionModal('Edit Overlay Association', terrPosOverlay.Id, overlayTeamInstance.Id);
        list<ObjectDetailWrapper.FieldDetailWrapper> wrapperList = new list<ObjectDetailWrapper.FieldDetailWrapper>();
        for(ObjectDetailWrapper.PositionAttributeWrapper posWrap : editWrapper.positionAttributes){
            //wrapperList = posWrap.rowDataConfig;
            wrapperList.add(wrapper1);
        }
        for(ObjectDetailWrapper.PositionAttributeWrapper posWrapper : editWrapper.positionAttributes){
            for(ObjectDetailWrapper.FieldDetailWrapper fieldWrapper1 : posWrapper.rowDataConfig){

                if(fieldWrapper1.fieldDataType == 'Text'){
                    if(fieldWrapper1.fieldLabel == 'Name'){
                        System.debug('fieldWrapper -- '+fieldWrapper1);
                       
                        fieldWrapper1.fieldValue = 'abd xyz';
                        System.debug('fieldWrapper -- '+fieldWrapper1);
                    }
                }
            }
        }

        list<ObjectDetailWrapper.BasePositionsWrapper> basePositionsList = SalesIQPositionManagementCtlr.getBasePositionData(terrPosOverlay.Id, overlayTeamInstance.Id, 'Edit Overlay Association');
        terrPosOverlay.Effective_Start_Date__c = Date.newInstance(2014,01,01);
        update terrPosOverlay;
        
        SalesIQPositionManagementCtlr.validatePosition('Edit Overlay Association',overlayTeamInstance.Id, JSON.serialize(editWrapper),JSON.serialize(basePositionsList),'d/M/yyyy');
        SalesIQPositionManagementCtlr.confirmSubmitRequest('Edit Overlay Association', terrPosOverlay.Id,overlayTeamInstance.Id, JSON.serialize(editWrapper),JSON.serialize(basePositionsList),'[]','d/M/yyyy');

        
        ObjectDetailWrapper editWrapper1 = SalesIQPositionManagementCtlr.initPositionModal('Edit Overlay Association', terrPosOverlay1.Id, overlayTeamInstance.Id);
        list<ObjectDetailWrapper.BasePositionsWrapper> basePositionsList2 = SalesIQPositionManagementCtlr.getBasePositionData(terrPosOverlay1.Id, overlayTeamInstance.Id, 'Edit Overlay Association');
        terrPosOverlay1.Effective_End_Date__c = Date.newInstance(2013, 01, 01);
        terrPosOverlay1.Effective_Start_Date__c = Date.newInstance(2018, 01, 01);
        update terrPosOverlay1;
        SalesIQPositionManagementCtlr.validatePosition('Edit Overlay Association',overlayTeamInstance.Id, JSON.serialize(editWrapper1),JSON.serialize(basePositionsList2),'d/M/yyyy');
        SalesIQPositionManagementCtlr.confirmSubmitRequest('Edit Overlay Association', terrPosOverlay1.Id,overlayTeamInstance.Id, JSON.serialize(editWrapper1),JSON.serialize(basePositionsList2),'[]','d/M/yyyy');

        //system.assert(false, [select id, Base_Position_Team_Instance__r.Position_Id__r.name, Base_Position__r.Name, Related_Position__r.Name, Assignment_Status__c from Related_Position__c]);
        
        test.stopTest();
    }

    static testMethod void deletePosition(){
        /****************** Delete Position *****************************/
        test.startTest();

        terrPosOverlay.inactive__c = false;
        terrPosOverlay.Related_Position_Type__c = 'Overlay';
        update terrPosOverlay;

        ObjectDetailWrapper wrapperdelete2 = SalesIQPositionManagementCtlr.initPositionModal('Delete Position', terrPosOverlay.Id, overlayTeamInstance.Id);
        terrPosOverlay.Effective_End_Date__c  = null;
        update terrPosOverlay; 
        SalesIQPositionManagementCtlr.validatePosition('Delete Position',overlayTeamInstance.Id, JSON.serialize(wrapperdelete2),'','d/M/yyyy');
        // SalesIQPositionManagementCtlr.validatePosition('Delete Position',overlayTeamInstance.Id, JSON.serialize(wrapper),'');
        SalesIQPositionManagementCtlr.confirmSubmitRequest('Delete Position', terrPosOverlay.Id,overlayTeamInstance.Id, JSON.serialize(wrapperdelete2),'','[]','d/M/yyyy');


        
        ObjectDetailWrapper wrapperDelete = SalesIQPositionManagementCtlr.initPositionModal('Delete Position', terrPos.Id, baseTeamInstance.Id);

        for(ObjectDetailWrapper.PositionAttributeWrapper posWrapper : wrapperDelete.positionAttributes){
            for(ObjectDetailWrapper.FieldDetailWrapper fieldWrapper : posWrapper.rowDataConfig){

                if(fieldWrapper.fieldDataType == 'Date'){
                    if(fieldWrapper.fieldLabel == 'Effective End Date'){
                        System.debug('fieldWrapper -- '+fieldWrapper);
                        Date newData = Date.parse(fieldWrapper.oldfieldvalue) - 1;
                        fieldWrapper.fieldValue = string.valueOf(newData);
                    }
                    
                }
                
            }
       }

       posGlobal.Child_Effective_Dates_within_Parent__c = false;
       update posGlobal;
        //SalesIQPositionManagementCtlr.initPositionModal('Delete Position', terrPos.Id, baseTeamInstance.Id);
        SalesIQPositionManagementCtlr.validatePosition('Delete Position',baseTeamInstance.Id, JSON.serialize(wrapperDelete),'','d/M/yyyy');
        SalesIQPositionManagementCtlr.confirmSubmitRequest('Delete Position', terrPos.Id,baseTeamInstance.Id, JSON.serialize(wrapperDelete),'','[]','d/M/yyyy');

        districtPos.inactive__c = false;
        districtPos.Related_Position_Type__c = 'Overlay';
        update districtPos;

        baseTeamInstance.IsCascadeDeleteAssignments__c = true;
        update baseTeamInstance;
        ObjectDetailWrapper wrapperDelete1 = SalesIQPositionManagementCtlr.initPositionModal('Delete Position', districtPos.Id, baseTeamInstance.Id);

        //SalesIQPositionManagementCtlr.initPositionModal('Delete Position',districtPos.Id, baseTeamInstance.Id);
        SalesIQPositionManagementCtlr.validatePosition('Delete Position',baseTeamInstance.Id, JSON.serialize(wrapperDelete1),'','d/M/yyyy');
        SalesIQPositionManagementCtlr.confirmSubmitRequest('Delete Position', districtPos.Id,baseTeamInstance.Id, JSON.serialize(wrapperDelete1),'','[]','d/M/yyyy');
        test.stopTest();
    
    }
    
    static testMethod void editEmployee(){

        Team_Instance_Object_Attribute__c teamInstAttr =  new Team_Instance_Object_Attribute__c();
        teamInstAttr.Interface_Name__c = SalesIQGlobalConstants.ROSTER_EDIT_EMPLOYEE;
        teamInstAttr.Attribute_API_Name__c = 'Name';
        teamInstAttr.Object_Name__c = SalesIQGlobalConstants.NAME_SPACE  + 'Employee__c';
        teamInstAttr.Data_Type__c = 'Text';
        teamInstAttr.Attribute_Display_Name__c = 'Name';
        teamInstAttr.isEnabled__c = true;
        teamInstAttr.isEditable__c = true;
        teamInstAttr.isRequired__c   = true;
        teamInstAttr.Display_Column_Order__c = 1;

        insert teamInstAttr;

        Team_Instance_Object_Attribute__c teamInstAttr2 =  new Team_Instance_Object_Attribute__c();
        teamInstAttr2.Interface_Name__c = SalesIQGlobalConstants.ROSTER_EDIT_EMPLOYEE;
        teamInstAttr2.Attribute_API_Name__c = SalesIQGlobalConstants.NAME_SPACE  + 'HR_Termination_Date__c';
        teamInstAttr2.Object_Name__c = SalesIQGlobalConstants.NAME_SPACE  + 'Employee__c';
        teamInstAttr2.Data_Type__c = 'Date';
        teamInstAttr2.Attribute_Display_Name__c = 'Termination Date';
        teamInstAttr2.isEnabled__c = true;
        teamInstAttr2.isEditable__c = true;
        teamInstAttr2.isRequired__c  = true;
        teamInstAttr2.Display_Column_Order__c = 2;

        insert teamInstAttr2;

        Employee__c emp = new Employee__c();
        emp.Name = 'Lagnika Sharma';
        emp.Last_Name__c = 'Sharma';
        emp.FirstName__c = 'Lagnika';
        insert emp;

        
        ObjectDetailWrapper wrapper = SalesIQPositionManagementCtlr.initPositionModal('Edit Employee', emp.Id, '');
        SalesIQPositionManagementCtlr.validatePosition('Edit Employee','', JSON.serialize(wrapper),'','d/M/yyyy');
        SalesIQPositionManagementCtlr.confirmSubmitRequest('Edit Employee', '','', JSON.serialize(wrapper),'','[]','d/M/yyyy');
    }

    
    static testMethod void advanceSearch(){ 
        
        List<BROperatorsWrapper> operatorWrapper = SalesIQPositionManagementCtlr.getOperatorValues();
        String queryString = 'Select id, '+SalesIqGlobalConstants.NAME_SPACE+'Client_Position_Code__c, '+SalesIqGlobalConstants.NAME_SPACE+'Client_Territory_Code__c from '+SalesIqGlobalConstants.NAME_SPACE+'Position__c';
        SalesIQPositionManagementCtlr.createColumnWrapperData(queryString);

        SalesIQPositionManagementCtlr.initializeBlock('');
        SalesIQPositionManagementCtlr.createCriteria();


    }
}